searchNodes=[{"ref":"Grains.html","title":"Grains","type":"module","doc":"Grains describes data flow as a graph with interchangeable parts. To accomplish that grains divides the graph (Recipe) from the implementation of the nodes (Grains). Together these parts can be used to make a Bread which describes how the graph translates to processes. Each process has a symbolic short name, which is resolved to the registered name of the process via a map (%Bread{}.process_map)."},{"ref":"Grains.html#combine/2","title":"Grains.combine/2","type":"function","doc":"Combine two sets of recipes and grains."},{"ref":"Grains.html#concat_name/2","title":"Grains.concat_name/2","type":"function","doc":""},{"ref":"Grains.html#default_grains/0","title":"Grains.default_grains/0","type":"function","doc":"This function describes the default implementations for auxiliary grains, for example the periodic timer. Currently these default grains are provided: iex&gt; Grains.default_grains() %{periodic: Grains.Timer}"},{"ref":"Grains.html#get_name/2","title":"Grains.get_name/2","type":"function","doc":""},{"ref":"Grains.html#get_substate/1","title":"Grains.get_substate/1","type":"function","doc":"Retrieve a grain&#39;s substate. This is similar to :sys.get_state/1. Note that this function should usually not be used, but it can be useful for debugging or testing. Errors The function exits the caller on error. For example, if no bread with the supplied id can be found, this results in a no_proc exit."},{"ref":"Grains.html#make_bread_name/2","title":"Grains.make_bread_name/2","type":"function","doc":""},{"ref":"Grains.html#make_name/3","title":"Grains.make_name/3","type":"function","doc":""},{"ref":"Grains.html#merge/2","title":"Grains.merge/2","type":"function","doc":"Merges two grain maps into one. The function works the same as Map.merge/2: all grains in the second argument are added to the first, overriding any existing one."},{"ref":"Grains.html#merge_recipes/3","title":"Grains.merge_recipes/3","type":"function","doc":"See Grains.Recipe.merge/3."},{"ref":"Grains.html#new/1","title":"Grains.new/1","type":"function","doc":""},{"ref":"Grains.html#new_recipe/2","title":"Grains.new_recipe/2","type":"function","doc":"See Grains.Recipe.new/2."},{"ref":"Grains.html#periodic/3","title":"Grains.periodic/3","type":"function","doc":"Description of a periodic grain."},{"ref":"Grains.html#start_supervised/3","title":"Grains.start_supervised/3","type":"function","doc":"See Grains.Supervisor.start_link/3."},{"ref":"Grains.Bread.html","title":"Grains.Bread","type":"module","doc":"A %Bread{} is the compiled version of Recipe plus Grains that allow the Supervisor to run the processes and wire them correctly."},{"ref":"Grains.Bread.html#bake/3","title":"Grains.Bread.bake/3","type":"function","doc":"Takes a recipe, grains and optionally a map of default implementations and returns a bread. Does not start any processes yet. Optional Arguments :default_grains Replace the default grains :id Set a custom bread id"},{"ref":"Grains.Bread.html#check/1","title":"Grains.Bread.check/1","type":"function","doc":""},{"ref":"Grains.Bread.html#gen_id/0","title":"Grains.Bread.gen_id/0","type":"function","doc":"Generates a random atom to be used as an id for the Bread"},{"ref":"Grains.Bread.html#t:t/0","title":"Grains.Bread.t/0","type":"type","doc":""},{"ref":"Grains.DebugTimer.html","title":"Grains.DebugTimer","type":"module","doc":"Debug version of Grains.Timer. To replace the normal Timer with this, start you bread like this: default_grains = Map.merge(Grains.default_grains, %{periodic: Grains.DebugTimer}) {:ok, bread} = Grains.Supervisor.start_link(recipe, grains, default_grains) server = Grains.get_name(bread, State) debug_timer = Grains.get_name(bread, State.Sampler.Timer) send(debug_timer, :tick) With Timestamps Similarly to Grains.Timer, the debug timer accepts an option with_timestamps. If set to true, the :tick must include a timestamp, which is then used when forwarding the received message downstream. If with_timestamps is not set, the :tick must not include a timestamp, and the message is forwarded as-is."},{"ref":"Grains.DebugTimer.html#child_spec/1","title":"Grains.DebugTimer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Grains.DebugTimer.html#handle_push/3","title":"Grains.DebugTimer.handle_push/3","type":"function","doc":""},{"ref":"Grains.DebugTimer.html#init/1","title":"Grains.DebugTimer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Grains.DebugTimer.html#name/2","title":"Grains.DebugTimer.name/2","type":"function","doc":"See Grains.Timer.name/2."},{"ref":"Grains.DebugTimer.html#own_full_name/0","title":"Grains.DebugTimer.own_full_name/0","type":"function","doc":"See Grains.GenGrain.own_full_name/0."},{"ref":"Grains.DebugTimer.html#own_name/0","title":"Grains.DebugTimer.own_name/0","type":"function","doc":"See Grains.GenGrain.own_name/0."},{"ref":"Grains.DebugTimer.html#pull/0","title":"Grains.DebugTimer.pull/0","type":"function","doc":"See Grains.GenGrain.pull/0."},{"ref":"Grains.DebugTimer.html#pull/1","title":"Grains.DebugTimer.pull/1","type":"function","doc":"See Grains.GenGrain.pull/1."},{"ref":"Grains.DebugTimer.html#push/1","title":"Grains.DebugTimer.push/1","type":"function","doc":"See Grains.GenGrain.push/1."},{"ref":"Grains.DebugTimer.html#push/2","title":"Grains.DebugTimer.push/2","type":"function","doc":"See Grains.GenGrain.push/2."},{"ref":"Grains.DebugTimer.State.html","title":"Grains.DebugTimer.State","type":"module","doc":""},{"ref":"Grains.GenGrain.html","title":"Grains.GenGrain","type":"module","doc":""},{"ref":"Grains.GenGrain.html#child_spec/1","title":"Grains.GenGrain.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Grains.GenGrain.html#full_name/1","title":"Grains.GenGrain.full_name/1","type":"function","doc":""},{"ref":"Grains.GenGrain.html#handle_continue/2","title":"Grains.GenGrain.handle_continue/2","type":"function","doc":"Invoked to handle continue instructions. It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way. Return values are the same as c:handle_cast/2. This callback is optional. If one is not implemented, the server will fail if a continue instruction is used. This callback is only supported on Erlang/OTP 21+. Callback implementation for GenServer.handle_continue/2."},{"ref":"Grains.GenGrain.html#init/1","title":"Grains.GenGrain.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Grains.GenGrain.html#own_full_name/0","title":"Grains.GenGrain.own_full_name/0","type":"function","doc":""},{"ref":"Grains.GenGrain.html#own_name/0","title":"Grains.GenGrain.own_name/0","type":"function","doc":""},{"ref":"Grains.GenGrain.html#pull/0","title":"Grains.GenGrain.pull/0","type":"function","doc":""},{"ref":"Grains.GenGrain.html#pull/1","title":"Grains.GenGrain.pull/1","type":"function","doc":""},{"ref":"Grains.GenGrain.html#push/1","title":"Grains.GenGrain.push/1","type":"function","doc":""},{"ref":"Grains.GenGrain.html#push/2","title":"Grains.GenGrain.push/2","type":"function","doc":""},{"ref":"Grains.GenGrain.html#start_link/5","title":"Grains.GenGrain.start_link/5","type":"function","doc":""},{"ref":"Grains.Recipe.html","title":"Grains.Recipe","type":"module","doc":"A Recipe describes the data flow between the processes."},{"ref":"Grains.Recipe.html#merge/3","title":"Grains.Recipe.merge/3","type":"function","doc":"Merges to recipes by combining all edges."},{"ref":"Grains.Recipe.html#new/2","title":"Grains.Recipe.new/2","type":"function","doc":""},{"ref":"Grains.Recipe.html#t:t/0","title":"Grains.Recipe.t/0","type":"type","doc":""},{"ref":"Grains.Supervisor.html","title":"Grains.Supervisor","type":"module","doc":""},{"ref":"Grains.Supervisor.html#child_spec/1","title":"Grains.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Grains.Supervisor.html#get_bread_supervisor/1","title":"Grains.Supervisor.get_bread_supervisor/1","type":"function","doc":"Retrieve the bread supervisor. Crashes if :bread_supervisor is not started."},{"ref":"Grains.Supervisor.html#get_root_name/1","title":"Grains.Supervisor.get_root_name/1","type":"function","doc":"Retrieve the root bread name. This function assumes that the supervisor has a registered name."},{"ref":"Grains.Supervisor.html#init/1","title":"Grains.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Grains.Supervisor.html#start_link/3","title":"Grains.Supervisor.start_link/3","type":"function","doc":""},{"ref":"Grains.Supervisor.html#which_grains/1","title":"Grains.Supervisor.which_grains/1","type":"function","doc":"Retrieve the id and registered name of currently running grains."},{"ref":"Grains.Supervisor.html#t:t/0","title":"Grains.Supervisor.t/0","type":"type","doc":""},{"ref":"Grains.Timer.html","title":"Grains.Timer","type":"module","doc":"A periodic timer."},{"ref":"Grains.Timer.html#child_spec/1","title":"Grains.Timer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Grains.Timer.html#handle_push/3","title":"Grains.Timer.handle_push/3","type":"function","doc":""},{"ref":"Grains.Timer.html#init/1","title":"Grains.Timer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Grains.Timer.html#name/2","title":"Grains.Timer.name/2","type":"function","doc":""},{"ref":"Grains.Timer.html#own_full_name/0","title":"Grains.Timer.own_full_name/0","type":"function","doc":"See Grains.GenGrain.own_full_name/0."},{"ref":"Grains.Timer.html#own_name/0","title":"Grains.Timer.own_name/0","type":"function","doc":"See Grains.GenGrain.own_name/0."},{"ref":"Grains.Timer.html#pull/0","title":"Grains.Timer.pull/0","type":"function","doc":"See Grains.GenGrain.pull/0."},{"ref":"Grains.Timer.html#pull/1","title":"Grains.Timer.pull/1","type":"function","doc":"See Grains.GenGrain.pull/1."},{"ref":"Grains.Timer.html#push/1","title":"Grains.Timer.push/1","type":"function","doc":"See Grains.GenGrain.push/1."},{"ref":"Grains.Timer.html#push/2","title":"Grains.Timer.push/2","type":"function","doc":"See Grains.GenGrain.push/2."},{"ref":"Grains.Timer.State.html","title":"Grains.Timer.State","type":"module","doc":""}]